Subject: Re: [PATCH] tcp: efficient port randomisation (revised)

From: Michael Vittrup Larsen <[email-masked]>
Date: Mon, 6 Dec 2004 09:18:04 +0100

Measuring non-blocking connect using the loopback address I agree with 
Stephen' conclusion, that the cost of the MD4 gets lost in the noise.

I did not measure the variance, since this probably describe scheduling and 
not the actual ephemeral bind.  However, I did measure the minimum value, and 
the assumption is that this is close to a measurement of an uninterrupted 
connect.  Median filtering probably would be more correct...

Below are the results from 10 successive tests.

Unmodified (average and minimum values):

connect 24433 (min 21820) [ticks/op]
connect 24504 (min 21927) [ticks/op]
connect 24530 (min 21952) [ticks/op]
connect 24244 (min 21607) [ticks/op]
connect 24220 (min 21613) [ticks/op]
connect 24117 (min 21665) [ticks/op]
connect 24148 (min 21663) [ticks/op]
connect 24079 (min 21648) [ticks/op]
connect 23998 (min 21700) [ticks/op]
connect 23906 (min 21682) [ticks/op]

Modified (average and minimum values):

connect 23961 (min 21774) [ticks/op]
connect 23894 (min 21750) [ticks/op]
connect 23927 (min 21776) [ticks/op]
connect 23881 (min 21757) [ticks/op]
connect 23956 (min 21749) [ticks/op]
connect 23872 (min 21710) [ticks/op]
connect 23848 (min 21694) [ticks/op]
connect 23729 (min 21769) [ticks/op]
connect 23656 (min 21618) [ticks/op]
connect 23723 (min 21699) [ticks/op]